<template>
  <div class="setGird">
    <div class="header-middle">
      <div class="hint">
        <span v-for="(item, index) in slectList" :key="index"><span v-if="index" style="margin:0 4px;">/</span><span style="color:#3F8DF5" @click="girdNameClick(item, index)">{{item.girdName}}</span></span>
      </div>

      <div class="showTypes" v-if="!userList.length">
        <div v-if="treeList.length > 0">
          <div class="cards" v-for="(item, index) in treeList" :key="index">
            <div class="imges">
              <span v-if="item.girdRight == 1 && item.girdLevel != 2">
                <img src="./components/img/xzh.png" alt="" class="imgselect" v-if="item.isChecked" @click.stop="girdClick(item, index)" />
                <img src="./components/img/xz.png" alt="" class="imgselect" v-else @click.stop="girdClick(item, index)" />
              </span>
              <span v-else style="width:24px;"></span>
              <img src="./components/img/gird--select-icon.png" alt="" class="avatras" />
            </div>
            <div class="rightes">
              <div class="applicationNames" @click="showGirdInfo(item)">{{ item.girdName }}</div>
              <div class="right-icon" v-if="item.girdLevel != 2" @click="itemClick(item)" >
                <img src="./components/img/right-icon.png" alt="" class="imgs" />
              </div>
            </div>
          </div>
        </div>

        <AiEmpty description="暂无数据" class="emptyWrap" v-else></AiEmpty>
      </div>
    </div>
    <!-- <div style="padding-bottom: 70px;"></div> -->
    <div class="subBtn" @click="toAddGird">
      <div>添加网格</div>
    </div>

     <u-popup v-model="show" mode="bottom" border-radius="14" height="1000">
      <div class="popup">
        <div class="bg"></div>
        <div class="title">{{ form.girdName }}</div>
       <div class="info-flex">
          <span class="label">网格类型</span>
          <span class="value">{{ $dict.getLabel('girdType', form.girdType) }}</span>
        </div>
        <div class="info-flex">
          <span class="label">网格层级</span>
          <span class="value">{{ $dict.getLabel('girdLevel', form.girdLevel) }}</span>
        </div>
        <div v-if="form.girdMemberManageList && form.girdMemberManageList.length">
          <div class="info-flex" v-for="(item, index) in  form.girdMemberManageList" :key="index">
            <span class="label">网格长</span>
            <span class="value">{{ item.name }}&nbsp;&nbsp;{{ item.phone }}
              <img :src="$cdn + 'common/phone.png'" alt="" @click="callPhone(item.phone)" class="phone-icon"
                   v-if="item.phone">
            </span>
          </div>
        </div>
        <div v-if="form.girdMemberList && form.girdMemberList.length">
          <div class="info-flex" v-for="(item, index) in  form.girdMemberList" :key="index">
            <span class="label">网格员</span>
            <span class="value">{{ item.name }}&nbsp;&nbsp;{{ item.phone }}
              <img :src="$cdn + 'common/phone.png'" alt="" @click="callPhone(item.phone)" class="phone-icon"
                   v-if="item.phone">
            </span>
          </div>
        </div>
        <div style="height:56px;"></div>
        <div class="btn" v-if="form.girdRight == 1">
          <span class="del" @click="del">删除网格</span>
          <span class="edit" @click="edit">编辑网格</span>
        </div>
      </div>
    </u-popup>

  </div>
</template>

<script>
export default {
  name: 'setGird',
  data() {
    return {
      setGird: {},
      allData: null,
      treeList: [],
      slectList: [],
      userList: [],

      show: false,
      form: {},
    }
  },
  onLoad() {
    this.$dict.load('girdType', 'girdLevel')
    this.isGirdUser()
    uni.$on('update',  () => {
      this.show = false
      this.getTree()
    })
  },
  methods: {
    isGirdUser() {
      this.$http.post('/app/appgirdmemberinfo/checkLogOnUser').then((res) => {
        if (res.code == 0) {
          if (res.data.checkType) {
            this.userGird = res.data
            this.getTree()
          } else {
            this.$u.toast('当前人员不是网格员或网格管理员')
          }
        }
      })
    },
    getTree() {
      this.slectList = []
      this.$http.post(`/app/appgirdinfo/queryAppGirdInfoByGirdLevel?girdLevel=0&girdMemberId=${this.userGird.girdMemberId}&parentGirdId=`).then((res) => {
        if (res?.data) {
          this.allData = res.data
          this.treeInit()
        }
      })
    },

    treeInit() {
      this.treeList = this.allData
      this.treeList.map((item) => {
        item.isChecked = false
      })
      var obj = {
        girdName: '可选范围',
        id: '',
        girdLevel: ''
      }
      this.slectList.push(obj)
    },

    itemClick(row) {
      if(row.girdLevel == 2) return
      var obj = {
        girdName: row.girdName,
        id: row.id,
        girdLevel: row.girdLevel
      }
      this.slectList.push(obj)
      this.searckGird(row)
    },

    searckGird(row) {
      if(row.girdLevel == 2) return
      var girdLevel = Number(row.girdLevel)+1
      this.$http.post(`/app/appgirdinfo/queryAppGirdInfoByGirdLevel?girdLevel=${girdLevel}&girdMemberId=${this.userGird.girdMemberId}&parentGirdId=${row.id}`).then((res) => {
        if (res?.data) {
          this.treeList = res.data
          this.setGird = {}
        }
      })
    },

    girdNameClick(row, index) {
      this.userList = []
      if(!index) { //第一级别
        this.slectList = []
        this.treeInit()
      }else {
        var list = []
        this.slectList.map((item, i) => {
          if(i <= index) {
            list.push(item)
          }
        })
        this.slectList = list
        this.searckGird(row)
      }
    },
    

    girdClick(row, index) {
      if (this.treeList[index].isChecked) {//取消
        this.treeList[index].isChecked = false
        this.setGird = {}
      } else {
        this.treeList.map((item) => {
          item.isChecked = false
        })
        this.treeList[index].isChecked = true
        this.setGird = row
      }
      this.$forceUpdate()
    },

    showGirdInfo(row) {
      this.show = true
      this.form = row
    },

    del() {
      this.$confirm(`是否删除该网格？`).then(() => {
        this.$http.post(`/app/appgirdinfo/delete?ids=${this.form.id}`).then((res) => {
          if (res.code == 0) {
            this.$u.toast('删除成功!')
            this.show = false
            this.form = {}
            this.treeList = []
            this.isGirdUser()
          }
        }).catch((err) => {
          this.$u.toast(err)
        })
      })
    },

    edit() {
      uni.navigateTo({url: `./AddGird?id=${this.form.id}&fromType=edit`})
    },

    callPhone(phone) {
      uni.makePhoneCall({phoneNumber: phone})
    },

    toAddGird() {
      if (this.setGird.id != null) {
        uni.navigateTo({url: `./AddGird?id=${this.setGird.id}&fromType=add`})
      } else {
        return this.$u.toast('请选择网格')
      }
    }
  }
}
</script>

<style scoped lang="scss">
.setGird {
  height: 100%;
  background: #fff;
  padding-bottom: 140px;
  .header-top {
    background: #fff;
    padding: 20px 32px;
  }

  .header-middle {
    .hint {
      padding: 28px 20px 28px 32px;
      line-height: 56px;
      box-shadow: 0px 1px 0px 0px #e4e5e6;
      font-size: 30px;
      font-weight: 500;
      word-break: break-all;
    }

    .showTypes {
      .empty-div {
        height: 16px;
        background: #f5f5f5;
      }

      .cards {
        display: flex;
        align-items: center;
        height: 120px;
        line-height: 120px;
        // background: pink;
        padding: 0 0 0 32px;

        .imges {
          display: flex;
          align-items: center;
          // width: 200px;
          .imgselect {
            width: 48px;
            height: 48px;
            vertical-align: middle;
          }

          .avatras {
            width: 74px;
            height: 74px;
            border-radius: 8px;
            margin-left: 36px;
          }
        }
        img {
          width: 74px;
          height: 74px;
          border-radius: 8px;
        }
        .rightes {
          width: calc(100% - 140px);
          display: flex;
          justify-content: space-between;
          align-items: center;
          margin-left: 32px;
          border-bottom: 1px solid #e4e5e6;
          .applicationNames {
            width: calc(100% - 100px);
            font-size: 36px;
            font-weight: 500;
            color: #333333;
            overflow:hidden; 
            text-overflow:ellipsis; 
            white-space:nowrap;
          }
          .right-icon{
            width: 100px;
            padding-right: 32px;
            box-sizing: border-box;
            text-align: right;
          }
          .imgs {
            width: 40px;
            height: 40px;
            margin-right: 20px;
          }
        }
      }
    }

    .showUsers {
      .cards {
        display: flex;
        align-items: center;
        height: 120px;
        line-height: 120px;
        // background: pink;
        padding: 0 0 0 32px;

        .imges {
          display: flex;
          align-items: center;
          width: 200px;
          .imgselect {
            width: 48px;
            height: 48px;
          }

          .avatras {
            width: 74px;
            height: 74px;
            border-radius: 8px;
            margin-left: 36px;
          }
        }

        .rights {
          width: 100%;
          display: flex;
          justify-content: space-between;
          align-items: center;
          margin-left: 32px;
          border-bottom: 1px solid #e4e5e6;
          padding-right: 40px;
          .applicationNames {
            font-size: 36px;
            font-weight: 500;
            color: #333333;
          }
          .idNumbers {
            color: #666;
          }
        }
      }
    }
  }

  .subBtn {
    position: fixed;
    bottom: 0;
    left: 0;
    width: 100%;
    height: 118px;
    background: #f4f8fb;
    div {
      width: 192px;
      height: 80px;
      line-height: 80px;
      text-align: center;
      background: #1365dd;
      border-radius: 4px;
      font-size: 32px;
      color: #fff;
      margin: 20px 34px 0 0;
      float: right;
    }
  }

  .popup {
    padding: 0 32px 16px;

    .bg {
      width: 64px;
      height: 10px;
      background: #CCC;
      border-radius: 6px;
      margin: 32px 0 32px 344px;
    }

    .title {
      font-size: 36px;
      font-family: PingFang-SC-Heavy, PingFang-SC;
      font-weight: 800;
      color: #333;
      line-height: 50px;
      margin-bottom: 24px;
    }

    .info-flex {
      padding: 26px 0 30px 0;
      width: 100%;
      border-bottom: 1px solid #D8DDE6;
      line-height: 40px;
      font-size: 28px;

      .label {
        display: inline-block;
        width: 160px;
        font-weight: 800;
        color: #333;
      }

      .value {
        color: #666;
        font-size: 26px;

        .phone-icon {
          width: 40px;
          height: 40px;
          vertical-align: sub;
          margin-left: 16px;
        }
      }
    }
    .border-b0{
      border-bottom: 0;
    }
    .btn{
      width: 100%;
      padding: 32px;
      box-sizing: border-box;
      background-color: #fff;
      display: flex;
      position: fixed;
      bottom: 0;
      left: 0;
      span{
        display: inline-block;
        height: 92px;
        line-height: 90px;
        border-radius: 8px;
        font-size: 34px;
        font-family: PingFangSC-Medium, PingFang SC;
        font-weight: 500;
        box-sizing: border-box;
        text-align: center;
      }
      .del{
        color: #f46;
        border: 1px solid #f46;
        flex: 1;
        margin-right: 32px;
      }
      .edit{
        background-color: #3671EE;
        color: #fff;
        flex: 2;
      }
    }
  }
}
</style>
